/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the ListCveIdsResponse type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ListCveIdsResponse{}

// ListCveIdsResponse struct for ListCveIdsResponse
type ListCveIdsResponse struct {
	// Total CVE records found
	TotalCount *int32 `json:"totalCount,omitempty"`
	// Number of CVE records in a page
	ItemsPerPage *int32 `json:"itemsPerPage,omitempty"`
	// Total number of pages
	PageCount *int32 `json:"pageCount,omitempty"`
	// Current page
	CurrentPage *int32 `json:"currentPage,omitempty"`
	// Previous page
	PrevPage *int32 `json:"prevPage,omitempty"`
	// Next page
	NextPage *int32 `json:"nextPage,omitempty"`
	CveIds []ListCveIdsResponseCveIdsInner `json:"cve_ids,omitempty"`
}

// NewListCveIdsResponse instantiates a new ListCveIdsResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListCveIdsResponse() *ListCveIdsResponse {
	this := ListCveIdsResponse{}
	return &this
}

// NewListCveIdsResponseWithDefaults instantiates a new ListCveIdsResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListCveIdsResponseWithDefaults() *ListCveIdsResponse {
	this := ListCveIdsResponse{}
	return &this
}

// GetTotalCount returns the TotalCount field value if set, zero value otherwise.
func (o *ListCveIdsResponse) GetTotalCount() int32 {
	if o == nil || IsNil(o.TotalCount) {
		var ret int32
		return ret
	}
	return *o.TotalCount
}

// GetTotalCountOk returns a tuple with the TotalCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListCveIdsResponse) GetTotalCountOk() (*int32, bool) {
	if o == nil || IsNil(o.TotalCount) {
		return nil, false
	}
	return o.TotalCount, true
}

// HasTotalCount returns a boolean if a field has been set.
func (o *ListCveIdsResponse) HasTotalCount() bool {
	if o != nil && !IsNil(o.TotalCount) {
		return true
	}

	return false
}

// SetTotalCount gets a reference to the given int32 and assigns it to the TotalCount field.
func (o *ListCveIdsResponse) SetTotalCount(v int32) {
	o.TotalCount = &v
}

// GetItemsPerPage returns the ItemsPerPage field value if set, zero value otherwise.
func (o *ListCveIdsResponse) GetItemsPerPage() int32 {
	if o == nil || IsNil(o.ItemsPerPage) {
		var ret int32
		return ret
	}
	return *o.ItemsPerPage
}

// GetItemsPerPageOk returns a tuple with the ItemsPerPage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListCveIdsResponse) GetItemsPerPageOk() (*int32, bool) {
	if o == nil || IsNil(o.ItemsPerPage) {
		return nil, false
	}
	return o.ItemsPerPage, true
}

// HasItemsPerPage returns a boolean if a field has been set.
func (o *ListCveIdsResponse) HasItemsPerPage() bool {
	if o != nil && !IsNil(o.ItemsPerPage) {
		return true
	}

	return false
}

// SetItemsPerPage gets a reference to the given int32 and assigns it to the ItemsPerPage field.
func (o *ListCveIdsResponse) SetItemsPerPage(v int32) {
	o.ItemsPerPage = &v
}

// GetPageCount returns the PageCount field value if set, zero value otherwise.
func (o *ListCveIdsResponse) GetPageCount() int32 {
	if o == nil || IsNil(o.PageCount) {
		var ret int32
		return ret
	}
	return *o.PageCount
}

// GetPageCountOk returns a tuple with the PageCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListCveIdsResponse) GetPageCountOk() (*int32, bool) {
	if o == nil || IsNil(o.PageCount) {
		return nil, false
	}
	return o.PageCount, true
}

// HasPageCount returns a boolean if a field has been set.
func (o *ListCveIdsResponse) HasPageCount() bool {
	if o != nil && !IsNil(o.PageCount) {
		return true
	}

	return false
}

// SetPageCount gets a reference to the given int32 and assigns it to the PageCount field.
func (o *ListCveIdsResponse) SetPageCount(v int32) {
	o.PageCount = &v
}

// GetCurrentPage returns the CurrentPage field value if set, zero value otherwise.
func (o *ListCveIdsResponse) GetCurrentPage() int32 {
	if o == nil || IsNil(o.CurrentPage) {
		var ret int32
		return ret
	}
	return *o.CurrentPage
}

// GetCurrentPageOk returns a tuple with the CurrentPage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListCveIdsResponse) GetCurrentPageOk() (*int32, bool) {
	if o == nil || IsNil(o.CurrentPage) {
		return nil, false
	}
	return o.CurrentPage, true
}

// HasCurrentPage returns a boolean if a field has been set.
func (o *ListCveIdsResponse) HasCurrentPage() bool {
	if o != nil && !IsNil(o.CurrentPage) {
		return true
	}

	return false
}

// SetCurrentPage gets a reference to the given int32 and assigns it to the CurrentPage field.
func (o *ListCveIdsResponse) SetCurrentPage(v int32) {
	o.CurrentPage = &v
}

// GetPrevPage returns the PrevPage field value if set, zero value otherwise.
func (o *ListCveIdsResponse) GetPrevPage() int32 {
	if o == nil || IsNil(o.PrevPage) {
		var ret int32
		return ret
	}
	return *o.PrevPage
}

// GetPrevPageOk returns a tuple with the PrevPage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListCveIdsResponse) GetPrevPageOk() (*int32, bool) {
	if o == nil || IsNil(o.PrevPage) {
		return nil, false
	}
	return o.PrevPage, true
}

// HasPrevPage returns a boolean if a field has been set.
func (o *ListCveIdsResponse) HasPrevPage() bool {
	if o != nil && !IsNil(o.PrevPage) {
		return true
	}

	return false
}

// SetPrevPage gets a reference to the given int32 and assigns it to the PrevPage field.
func (o *ListCveIdsResponse) SetPrevPage(v int32) {
	o.PrevPage = &v
}

// GetNextPage returns the NextPage field value if set, zero value otherwise.
func (o *ListCveIdsResponse) GetNextPage() int32 {
	if o == nil || IsNil(o.NextPage) {
		var ret int32
		return ret
	}
	return *o.NextPage
}

// GetNextPageOk returns a tuple with the NextPage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListCveIdsResponse) GetNextPageOk() (*int32, bool) {
	if o == nil || IsNil(o.NextPage) {
		return nil, false
	}
	return o.NextPage, true
}

// HasNextPage returns a boolean if a field has been set.
func (o *ListCveIdsResponse) HasNextPage() bool {
	if o != nil && !IsNil(o.NextPage) {
		return true
	}

	return false
}

// SetNextPage gets a reference to the given int32 and assigns it to the NextPage field.
func (o *ListCveIdsResponse) SetNextPage(v int32) {
	o.NextPage = &v
}

// GetCveIds returns the CveIds field value if set, zero value otherwise.
func (o *ListCveIdsResponse) GetCveIds() []ListCveIdsResponseCveIdsInner {
	if o == nil || IsNil(o.CveIds) {
		var ret []ListCveIdsResponseCveIdsInner
		return ret
	}
	return o.CveIds
}

// GetCveIdsOk returns a tuple with the CveIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListCveIdsResponse) GetCveIdsOk() ([]ListCveIdsResponseCveIdsInner, bool) {
	if o == nil || IsNil(o.CveIds) {
		return nil, false
	}
	return o.CveIds, true
}

// HasCveIds returns a boolean if a field has been set.
func (o *ListCveIdsResponse) HasCveIds() bool {
	if o != nil && !IsNil(o.CveIds) {
		return true
	}

	return false
}

// SetCveIds gets a reference to the given []ListCveIdsResponseCveIdsInner and assigns it to the CveIds field.
func (o *ListCveIdsResponse) SetCveIds(v []ListCveIdsResponseCveIdsInner) {
	o.CveIds = v
}

func (o ListCveIdsResponse) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ListCveIdsResponse) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.TotalCount) {
		toSerialize["totalCount"] = o.TotalCount
	}
	if !IsNil(o.ItemsPerPage) {
		toSerialize["itemsPerPage"] = o.ItemsPerPage
	}
	if !IsNil(o.PageCount) {
		toSerialize["pageCount"] = o.PageCount
	}
	if !IsNil(o.CurrentPage) {
		toSerialize["currentPage"] = o.CurrentPage
	}
	if !IsNil(o.PrevPage) {
		toSerialize["prevPage"] = o.PrevPage
	}
	if !IsNil(o.NextPage) {
		toSerialize["nextPage"] = o.NextPage
	}
	if !IsNil(o.CveIds) {
		toSerialize["cve_ids"] = o.CveIds
	}
	return toSerialize, nil
}

type NullableListCveIdsResponse struct {
	value *ListCveIdsResponse
	isSet bool
}

func (v NullableListCveIdsResponse) Get() *ListCveIdsResponse {
	return v.value
}

func (v *NullableListCveIdsResponse) Set(val *ListCveIdsResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListCveIdsResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListCveIdsResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListCveIdsResponse(val *ListCveIdsResponse) *NullableListCveIdsResponse {
	return &NullableListCveIdsResponse{value: val, isSet: true}
}

func (v NullableListCveIdsResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListCveIdsResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


